#include <iostream>
#include <stdlib.h>
#define USE_CONSOLE
#include "allegro.h"

using namespace std;

enum {
  RUUT_X = 0,
  RUUT_O = 1,
  RUUT_KONTROLLITUD = 2,
  RUUT_TYHI = 3
};

enum {
  X_VOITIS = 0,
  O_VOITIS = 1,
  VIIK = 2,
  MANG_KAIB = 3
};

enum {
  OLEK_VALIKUD,
  OLEK_MANG,
  OLEK_VIIK,
  OLEK_MANGIJA_VOIT,
  OLEK_ARVUTI_VOIT
};

int aktiivnetekst = 0;
char* tekstid[] = {
  "                                                           ",
  "See ei olnud kuigi hea kik. Mul on nd viduvimalus.    ",
  "Mina oleksin mujale kinud...                              ",
  "Mitte just parim kik.                                     ",
  "See vib meid viigini viia.                                ",
  "Enam te vita ei saa.                                      ",
  "Viik on hus...                                            ",
  "Mina vitsin. Jrgmine kord pange paremini thele!         ",
  "Te kaotasite. Enda kaitsmiseks kige keskmisesse ruutu.    ",
  "Jimegi viiki. Optimaalse mngu puhul nii juhtubki.        ",
  "Jlle viik. Mind ei ole programmeeritud kaotama :)         ",
  "Te vitsite. Seda ei tohiks tegelikult ette tulla...       "
};

DIALOG tripstrapstrull[] = 
{
//      (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)                  (d2)  (dp)              (dp2) (dp3)
// #0
      { d_text_proc,      25,  35,   200,  10,   255,  0,    0,    0,          0,                    0,    "TRIPS-",  0,    0},
      { d_text_proc,      70,  60,   200,  10,   255,  0,    0,    0,          0,                    0,    "TRAPS-",  0,    0},
      { d_text_proc,      140,  85,   200,  10,   255,  0,    0,    0,          0,                    0,    "TRULL",  0,    0},
      { d_text_proc,      25,   120,  200,  10,   255,  0,    0,    0,          0,                    0,    "Kas alustate?",  0,    0},
      { d_radio_proc,     25,   160,  200,  10,   255,  0,    0,    D_SELECTED, 0,                    0,    "&Jah",           0,    0},
      { d_radio_proc,     125,  160,  200,  10,   255,  0,    0,    0,          0,                    0,    "&Ei",            0,    0},
      { d_text_proc,      25,   200,  200,  10,   255,  0,    0,    0,          0,                    0,    "Ristid vi ringid?",   0,    0},
      { d_radio_proc,     25,   240,  200,  10,   255,  0,    0,    D_SELECTED, 1,                    0,    "&Ristid",         0,    0},
      { d_radio_proc,     125,  240,  200,  10,   255,  0,    0,    0,          1,                    0,    "R&ingid",         0,    0},
      { d_button_proc,    25,   360,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Alusta",        0,    0},
      { d_button_proc,    25,   400,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Lpeta",        0,    0},
      { d_yield_proc,     0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0},
      { 0,                0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0}
};

DIALOG soovidveel[] = 
{
      { d_button_proc,    25,   360,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Alusta uuesti",        0,    0},
      { d_button_proc,    25,   400,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Lpeta",        0,    0},
      { d_yield_proc,     0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0},
      { 0,                0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0}
};

BITMAP* ring = 0;
BITMAP* rist = 0;
BITMAP* ttt = 0;
BITMAP* tekst = 0;
int manguolek;
int olenx = 1;
int alustan = 1;
  
class laud {
public:
  int ruut[3][3];
  laud () { tyhjenda (); }

  void tyhjenda () {
    for (int i = 0; i < 3; i++) 
      for (int j = 0; j < 3; j++) 
        ruut[i][j] = RUUT_TYHI;
  }

  int on_tais () {
    for (int i = 0; i < 3; i++) {
      for (int j = 0; j < 3; j++) {
        if (ruut[i][j] == RUUT_TYHI)
          return false;
      }
    }
    return true;
  }

  int on_voitnud (int _mangija) {
      if (
        (ruut[0][0] == _mangija && ruut[0][1] == _mangija && ruut[0][2] == _mangija) ||
        (ruut[1][0] == _mangija && ruut[1][1] == _mangija && ruut[1][2] == _mangija) ||
        (ruut[2][0] == _mangija && ruut[2][1] == _mangija && ruut[2][2] == _mangija) ||
        (ruut[0][0] == _mangija && ruut[1][0] == _mangija && ruut[2][0] == _mangija) ||
        (ruut[0][1] == _mangija && ruut[1][1] == _mangija && ruut[2][1] == _mangija) ||
        (ruut[0][2] == _mangija && ruut[1][2] == _mangija && ruut[2][2] == _mangija) ||
        (ruut[0][0] == _mangija && ruut[1][1] == _mangija && ruut[2][2] == _mangija) ||
        (ruut[0][2] == _mangija && ruut[1][1] == _mangija && ruut[2][0] == _mangija))
        return true;
      return false;
  }

  int olek () {
    int x = on_voitnud (RUUT_X);
    if (x)
      return X_VOITIS;
    int o = on_voitnud (RUUT_O);
    if (o)
      return O_VOITIS;
    if (on_tais ())
      return VIIK;
    return MANG_KAIB;
  }
};

int hinda_lauda (laud* _laud, int _mangija, int* uusx, int* uusy) {
  int parimkaikx = 0, parimkaiky = 0;
  int parimhinnang = -20;

  int vaadeldavx = 0, vaadeldavy = 0;
  int vaadeldavhinnang = 0;

  int kaikkontrollitud = 0;
  laud testlaud;
  int i = 0, j = 0;
  int musttest = 1;

  int olek = _laud->olek ();
  if (olek == _mangija)   
    return 10;
  else if (olek == !_mangija)
    return -10;
  else if (olek == VIIK)
    return 0;
  
  while (musttest) {
    kaikkontrollitud = 0;
    for (i = 0; i < 3; i++) {
      for (j = 0; j < 3; j++) {
        if (_laud->ruut[i][j] == RUUT_X) {
          testlaud.ruut[i][j] = RUUT_X;                       
        } else if (_laud->ruut[i][j] == RUUT_O) {
          testlaud.ruut[i][j] = RUUT_O;                       
        } else if (_laud->ruut[i][j] == RUUT_KONTROLLITUD) {
          testlaud.ruut[i][j] = RUUT_TYHI;
        } else if (_laud->ruut[i][j] == RUUT_TYHI) {
          if (kaikkontrollitud == 0) {
            _laud->ruut[i][j] = RUUT_KONTROLLITUD;
            vaadeldavx = i;
            vaadeldavy = j;
            testlaud.ruut[i][j] = _mangija;
            kaikkontrollitud = 1;
          } else {
            testlaud.ruut[i][j] = RUUT_TYHI;
          }
        }
      }
    }
    if (kaikkontrollitud == 1) {
      vaadeldavhinnang = -1 * hinda_lauda (&testlaud, !_mangija, 0, 0);
      if (vaadeldavhinnang < 0)
        vaadeldavhinnang++;
      if (vaadeldavhinnang > 0)
        vaadeldavhinnang--;

      if (vaadeldavhinnang > parimhinnang) {
        parimhinnang = vaadeldavhinnang; 
        parimkaikx = vaadeldavx;
        parimkaiky = vaadeldavy;
      }
    } else {
      musttest = 0;
    }
  }

  for (i = 0; i < 3; i++) {
    for (j = 0; j < 3; j++) {
      if (_laud->ruut [i][j] == RUUT_KONTROLLITUD)
        _laud->ruut [i][j] = RUUT_TYHI;
    }
  }

  if (uusx && uusy) {
    *uusx = parimkaikx;
    *uusy = parimkaiky;
  }
  return parimhinnang;
}

void joonista_ring (int _x, int _y) {
  int x = 220 + (_x * 135);
  int y = 60 + (_y * 135);
  blit (ring, screen, 0,0, x, y, 100, 100);
} 

void joonista_rist (int _x, int _y) {
  int x = 220 + (_x * 130);
  int y = 60 + (_y * 130);
  blit (rist, screen, 0,0, x, y, 100, 100);
}

void joonista_laud (laud* _laud) {
  vsync ();
  scare_mouse ();
  acquire_bitmap (screen);
  textout (screen, font, "TRIPS-", 25, 35, makecol (0,0,0));
  textout (screen, font, "TRAPS-", 70, 60, makecol (0,0,0));
  textout (screen, font, "TRULL", 140, 85, makecol (0,0,0));
  rectfill (screen, 335, 50, 345, 430, makecol (0,0,0));
  rectfill (screen, 465, 50, 475, 430, makecol (0,0,0));
  rectfill (screen, 210, 175, 590, 185, makecol (0,0,0));
  rectfill (screen, 210, 305, 590, 315, makecol (0,0,0));
  for (int i = 0; i < 3; i++) {
    for (int j = 0; j < 3; j++) {
      if (_laud->ruut[j][i] == RUUT_X) {
        if (olenx)
          joonista_rist (j, i);
        else
          joonista_ring (j, i);
      }
      if (_laud->ruut[j][i] == RUUT_O) {
        if (!olenx)
          joonista_rist (j, i);
        else
          joonista_ring (j, i);
      }
    }
  }
  rectfill (screen, 0, 440, 640, 480, makecol (255, 255, 255));
  textout (screen,font, tekstid[aktiivnetekst], 50,440, makecol (0, 0, 0));  
  if (manguolek == OLEK_VIIK) {
    textout (screen,font, tekstid[9 + (rand () % 2)], 50,440, makecol (0, 0, 0));
  }
  else if (manguolek == OLEK_MANGIJA_VOIT) {
    textout (screen,font, tekstid[11], 50,440, makecol (0, 0, 0));
  }
  else if (manguolek == OLEK_ARVUTI_VOIT) {
    textout (screen,font, tekstid[7 + (rand () % 2)], 50,440, makecol (0, 0, 0));
  }

  release_bitmap (screen);
  unscare_mouse ();
}

void loe_hiirt (laud* _laud, int _mangija) {
  int ai_x, ai_y, olek;
  if (mouse_b & 1) {
    for (int i = 0; i < 3; i++) {
      for (int j = 0; j < 3; j++) {
        if ((mouse_x > (210 + j * 130)) && (mouse_x < (330 + j * 130)) && (mouse_y > (50 + i * 130)) && (mouse_y < (170 + i * 130))) {
          if (_laud->ruut[j][i] == RUUT_TYHI) {
            _laud->ruut[j][i] = _mangija;
            olek = _laud->olek ();
            if (olek == _mangija) {
              manguolek = OLEK_MANGIJA_VOIT;
              return;
            }
            if (olek == VIIK) {
              manguolek = OLEK_VIIK;
              return;
            }
            int hinnang = hinda_lauda (_laud, !_mangija, &ai_x, &ai_y);
            if (hinnang > 0)
              aktiivnetekst = 1 + (rand () % 3);
            if (hinnang == 0)
              aktiivnetekst = 4 + (rand () % 3);
            if (hinnang < 0)
              aktiivnetekst = 11;
              
            _laud->ruut[ai_x][ai_y] = !_mangija;
            olek = _laud->olek ();
            if (olek == !_mangija) {
              manguolek = OLEK_ARVUTI_VOIT;
              return;
            }
            if (olek == VIIK) {
              manguolek = OLEK_VIIK;
              return;
            }
          }
        }
      }
    }
  }
  mouse_b = 0;
}

int main(int argc, char *argv[])
{
  laud l;
  srand(time(0));
  set_uformat(U_ASCII);

  allegro_init ();
  set_window_title ("Trips-Traps-Trulli treener");
  if (desktop_color_depth () == 32)
    set_color_depth (32);
  if (desktop_color_depth () == 16)
    set_color_depth (16);
  if (set_gfx_mode (GFX_AUTODETECT_WINDOWED, 640, 480, 640, 480) < 0) {
    if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 640, 480) < 0) {
      allegro_message ("Pilti nidata ei nnestunud!");
    }
  }
  install_keyboard ();
  install_mouse ();

  clear_to_color (screen, makecol (255,255,255));
  show_mouse (screen);

  ring = create_bitmap (100, 100);
  clear_to_color (ring, makecol (255, 255, 255));
  circle (ring, 50, 50, 50, makecol (0,0,0));
  circle (ring, 50, 50, 45, makecol (0,0,0));
  floodfill (ring, 50, 3, makecol (0,0,0));
  
  rist = create_bitmap (100, 100);
  clear_to_color (rist, makecol (255, 255, 255));
  line (rist, 0, 5, 5, 0, makecol (0, 0, 0));
  line (rist, 5, 0, 100, 95, makecol (0, 0, 0));
  line (rist, 100, 95, 95, 100, makecol (0, 0, 0));
  line (rist, 95, 100, 0, 5, makecol (0, 0, 0));
  floodfill (rist, 50, 50, makecol (0,0,0));
  line (rist, 100, 5, 95, 0, makecol (0, 0, 0));
  line (rist, 95, 0, 0, 95, makecol (0, 0, 0));
  line (rist, 0, 95, 5, 100, makecol (0, 0, 0));
  line (rist, 5, 100, 100, 5, makecol (0, 0, 0));
  floodfill (rist, 95, 5, makecol (0,0,0));
  floodfill (rist, 5, 95, makecol (0,0,0));

  for (int ret = 0; tripstrapstrull[ret].proc; ret++) {
    tripstrapstrull[ret].bg = makecol(255, 255, 255);
    tripstrapstrull[ret].fg = makecol(0, 0, 0);
  }
  for (ret = 0; soovidveel[ret].proc; ret++) {
    soovidveel[ret].bg = makecol(255, 255, 255);
    soovidveel[ret].fg = makecol(0, 0, 0);
  }

  DATAFILE* andmed = load_datafile ("#");
  font = (FONT*)(andmed[0]).dat;
  text_mode (makecol (255,255,255));
  
  manguolek = OLEK_VALIKUD;
  int signal = 0;
  int ai_x, ai_y;

  while (1) {
    if (manguolek == OLEK_VALIKUD)  {
      signal = do_dialog (tripstrapstrull, 0);
      if (signal == 10)
        exit (0);
  
      if (tripstrapstrull[4].flags == D_SELECTED)
        alustan = 1;
      if (tripstrapstrull[5].flags == D_SELECTED) {
        alustan = 0;

        hinda_lauda (&l, RUUT_O, &ai_x, &ai_y);
        l.ruut[ai_x][ai_y] = RUUT_O;
      }
      if (tripstrapstrull[7].flags == D_SELECTED)
        olenx = 1;
      if (tripstrapstrull[8].flags == D_SELECTED)
        olenx = 0;
      
      manguolek = OLEK_MANG;
      scare_mouse ();
      clear_to_color (screen, makecol (255, 255,255));
      unscare_mouse ();
      aktiivnetekst = 0;
    } else if (manguolek == OLEK_MANG)  {
      joonista_laud (&l);
      loe_hiirt (&l, RUUT_X);
      yield_timeslice ();
    } else {
      joonista_laud (&l);
      signal = do_dialog (soovidveel, 0);
      if (signal == 1)
        exit (0);
      clear_to_color (screen, makecol (255, 255,255));
      manguolek = OLEK_VALIKUD;
      l.tyhjenda ();
      yield_timeslice ();
    }
  }
  return 0;
}
