// Tehisintellekt I 2. kodut
// Viieteistkmne-mng
// Dan Bogdanov , inf III


#include <iostream>
#define USE_CONSOLE
#include <allegro.h>

using namespace std;

enum {
  OLEK_ALUSTAMINE,
  OLEK_LAUA_LUGEMINE,
  OLEK_LAHENDAMINE,
  OLEK_MITTELAHENDUV_SEIS,
  OLEK_LAHENDATUD,
  OLEK_M6ISTUS_OTSAS
};

enum {
  RUUT_EITEA = -1,
  RUUT_TYHI = 0
};

enum {
  SUUND_SIINSAMAS,
  SUUND_VASAKULE,
  SUUND_PAREMALE,
  SUUND_YLES,
  SUUND_ALLA
};

enum {
  TULEMUS_ONPAIGAS,
  TULEMUS_POLEPAIGAS
};

enum {
  SKRIPT_NUMBER = 0,
  SKRIPT_X = 1,
  SKRIPT_Y = 2
};

int skript[30][3] = {
  {1, 0, 0},  // 0  1 paika
  {2, 1, 0},  // 1  2 paika
  {3, 3, 0},  // 2  3 ja 4 paika
  {4, 3, 1},  // 3  3 ja 4 paika
  {3, 2, 0},  // 4  3 ja 4 paika
  {4, 3, 0},  // 5  3 ja 4 paika
  {5, 0, 1},  // 6  5 paik
  {9, 0, 3}, // 7  9 ja 13 paika
  {13, 1, 3},  // 8  9 ja 13 paika
  {9, 0, 2},  // 9 9 ja 13 paika
  {13, 0, 3}, // 10  9 ja 13 paika
  {6, 1, 1},  // 11 6 paika
  {7, 3, 1},  // 12 7 ja 8 paika
  {8, 3, 2},  // 13 7 ja 8 paika
  {7, 2, 1},  // 14 7 ja 8 paika
  {8, 3, 1},  // 15 7 ja 8 paika
  {14, 1, 2}, // 16 10 ja 14 paika
  {10, 2, 2}, // 17 10 ja 14 paika
  {14, 1, 3}, // 18 10 ja 14 paika
  {10, 1, 2}, // 19 10 ja 14 paika
  {11, 2, 2}, // 20 11 paika
  {12, 3, 2}, // 21 12 paika
  {15, 2, 3}  // 22 15 paika
};
int skriptipikkus = 23;
int skriptisamm = 0;

int olek = OLEK_ALUSTAMINE;
int lisatavnumber = 1;
int viide = 500;

DIALOG nupud[] = 
{
      { d_button_proc,    25,   360,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Uus mng",        0,    0},
      { d_button_proc,    25,   400,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Lpeta",        0,    0},
      { d_yield_proc,     0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0},
      { 0,                0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0}
};


// Prototbid
class Laud4x4;
void joonista_laud (Laud4x4* _laud);
void loe_hiirt (Laud4x4* _laud);

class Laud4x4 {
public:
  int ruut[4][4];

  int inversioonid;
  int jada[17];
  int kontrollitud[17];

  bool kylastatud[4][4];

  void Tyhjenda () {
    inversioonid = 0;
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        ruut[i][j] = RUUT_EITEA;
        kylastatud[i][j] = 0;
      }
    }
  }

  void Tryki () {
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        cout << ruut[i][j] << " " ;
      }
      cout << endl;
    }
    cout << endl;
  }

  int SaabLahendada (){
    int tyhi_x = 0, tyhi_y = 0;
    int indeks = 1;

    for (int i = 0; i < 17; i++){
      kontrollitud[i] = 0;
    }
    
    for (i = 0; i < 4; i++){
      for(int j = 0; j < 4; j++){
        if (ruut[j][i] == RUUT_TYHI) {
          tyhi_x = i;
          tyhi_y = j;
        }
        jada[indeks] = ruut[j][i];
        indeks++;
      }
    }
    
    for(i = 1; i < 17; i++)
      JalitaArvu(i);

    inversioonid += 6 - tyhi_x - tyhi_y;

    if (inversioonid % 2)
        return 0;
    else
        return 1;
  }
 
  void JalitaArvu(int i){
    if(kontrollitud[i] == 1)
      return;
    else if (i == jada[i]){
      kontrollitud[i] = 1;
      return;
    }
    else{
       for(int j = 1; j < 17; j++){
          if (jada[j] == i){
            if (kontrollitud[j] == 1)
                break;
              inversioonid++;
              kontrollitud[i] = 1;
              JalitaArvu(j);
            }
        }
    }
  }

  void ViiTyhikRuudule (int _sx, int _sy) {
    int lx, ly;
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        if (ruut[i][j] == RUUT_TYHI) {
          lx = i;
          ly = j;
          break;
        }
      }
    }
    int tulemus = ParimSuund (lx, ly, _sx, _sy);
    if (tulemus == SUUND_VASAKULE) {
      ruut[lx][ly] = ruut[lx - 1][ly];
      ruut[lx - 1][ly] = RUUT_TYHI;
    } else if (tulemus == SUUND_PAREMALE) {
      ruut[lx][ly] = ruut[lx + 1][ly];
      ruut[lx + 1][ly] = RUUT_TYHI;
    } else if (tulemus == SUUND_ALLA) {
      ruut[lx][ly] = ruut[lx][ly + 1];
      ruut[lx][ly + 1] = RUUT_TYHI;
    } else if (tulemus == SUUND_YLES) {
      ruut[lx][ly] = ruut[lx][ly - 1];
      ruut[lx][ly - 1] = RUUT_TYHI;
    } else {
      olek = OLEK_M6ISTUS_OTSAS;
    }
  }

  int ParimSuund (int _lx, int _ly, int _sx, int _sy) {
    if (_lx == _sx && _ly == _sy)
      return SUUND_SIINSAMAS;

    int testx, testy;
    int lyhimtee = 100;
    int lyhimsuund = -1;
    int tulemus;

    kylastatud[_lx][_ly] = 1;

    // Proovime vasakule?
    testx = _lx - 1;
    testy = _ly;
    if (testx >= 0 && testx < 4 && testy >= 0 && testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
        lyhimsuund = SUUND_VASAKULE;
      }
    }

    // Proovime paremale?
    testx = _lx + 1;
    testy = _ly;
    if (testx >= 0 && testx < 4 && testy >= 0&& testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
        lyhimsuund = SUUND_PAREMALE;
      }
    }

    // Proovime les?
    testx = _lx;
    testy = _ly - 1;
    if (testx >= 0 && testx < 4 && testy >= 0&& testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
        lyhimsuund = SUUND_YLES;
      }
    }

    // Proovime alla?
    testx = _lx;
    testy = _ly + 1;
    if (testx >= 0 && testx < 4 && testy >= 0&& testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
        lyhimsuund = SUUND_ALLA;
      }
    }
    kylastatud[_lx][_ly] = 0;

    return lyhimsuund;
  }
  
  int LyhimaTeePikkus (int _lx, int _ly, int _sx, int _sy) {
    if (_lx == _sx && _ly == _sy)
      return 0;

    int testx, testy;
    int lyhimtee = 100;
    int lyhimsuund = -1;
    int tulemus;

    kylastatud[_lx][_ly] = 1;

    // Proovime vasakule?
    testx = _lx - 1;
    testy = _ly;
    if (testx >= 0 && testx < 4 && testy >= 0 && testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
      }
    }

    // Proovime paremale?
    testx = _lx + 1;
    testy = _ly;
    if (testx >= 0 && testx < 4 && testy >= 0&& testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
      }
    }

    // Proovime les?
    testx = _lx;
    testy = _ly - 1;
    if (testx >= 0 && testx < 4 && testy >= 0&& testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
      }
    }

    // Proovime alla?
    testx = _lx;
    testy = _ly + 1;
    if (testx >= 0 && testx < 4 && testy >= 0&& testy < 4 && kylastatud[testx][testy] == 0) {
      tulemus = LyhimaTeePikkus (testx, testy, _sx, _sy);
      if (tulemus < lyhimtee) {
        lyhimtee = tulemus;
      }
    }
    kylastatud[_lx][_ly] = 0;

    return lyhimtee + 1;
  }

  int ViiNumberRuudule (int _number, int _sx, int _sy) {
    int x, y;
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        if (ruut[i][j] == _number) {
          x = i;
          y = j;
          break;
        }
      }
    }

    int tx = x, ty = y;
    int parimsuund = ParimSuund (x, y, _sx, _sy);

    if (parimsuund == SUUND_SIINSAMAS) {
      kylastatud[x][y] = 1;
      return TULEMUS_ONPAIGAS;
    } else {
      if (parimsuund == SUUND_VASAKULE)
        tx--;
      else if (parimsuund == SUUND_PAREMALE)
        tx++;
      else if (parimsuund == SUUND_ALLA)
        ty++;
      else if (parimsuund == SUUND_YLES)
        ty--;

      if (ruut[tx][ty] == RUUT_TYHI) {
        ruut[tx][ty] = ruut[x][y];
        ruut[x][y] = RUUT_TYHI;
      } else {
        kylastatud[x][y] = 1;
        ViiTyhikRuudule (tx, ty);
      }
    }
    return TULEMUS_POLEPAIGAS;
  }

  void Mangi () {
    skriptisamm = 0;
    while (skriptisamm < skriptipikkus) {
      // Erijuhtude ttlus
      if (skriptisamm == 2) {
        if (ruut[2][0] == 3 && ruut[3][0] == 4) {
          skriptisamm = 6;
        }
        if (ruut[2][0] == 4 && ruut[3][0] == 3) {
          while (ruut[3][2] != 3) {
            ViiNumberRuudule (3, 3, 2);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
          while (ruut[2][2] != 4) {
            ViiNumberRuudule (4, 2, 2);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
        }
      }
      if (skriptisamm == 7) {
        if (ruut[0][2] == 9 && ruut[0][3] == 13) {
          skriptisamm = 11;
        }
        if (ruut[0][2] == 13 && ruut[0][3] == 9) {
          while (ruut[2][3] != 9) {
            ViiNumberRuudule (9, 2, 3);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
          while (ruut[2][2] != 13) {
            ViiNumberRuudule (13, 2, 2);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
          kylastatud[2][2] = 0;
          kylastatud[2][3] = 0;
        } 
      }
      if (skriptisamm == 8) {
        if (ruut[0][2] == RUUT_TYHI && ruut[0][3] == 9 && ruut[1][2] == 13) {
          ViiNumberRuudule (13, 0, 2);
          joonista_laud ((Laud4x4*)this);
          rest (viide);
          kylastatud[0][2] = 0;
          kylastatud[0][3] = 0;
          skriptisamm = 7;
          continue;
        }
      }
      if (skriptisamm == 12) {
        if (ruut[2][1] == 7 && ruut[3][1] == 8) {
          skriptisamm = 16;
        }
        if (ruut[2][1] == 8 && ruut[3][1] == 7) {
          while (ruut[3][3] != 7) {
            ViiNumberRuudule (7, 3, 3);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
          while (ruut[2][3] != 8) {
            ViiNumberRuudule (8, 2, 3);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
        }
      }
      if (skriptisamm == 13) {
        if (ruut[2][1] == RUUT_TYHI && ruut[3][1] == 7 && ruut[2][2] == 8) {
          ViiNumberRuudule (8, 2, 1);
          joonista_laud ((Laud4x4*)this);
          rest (viide);
          kylastatud[2][1] = 0;
          kylastatud[3][1] = 0;
          skriptisamm = 7;
          continue;
        }
      }
      if (skriptisamm == 16) {
        if (ruut[1][2] == 10 && ruut[1][3] == 14) {
          skriptisamm = 20;
        }
        if (ruut[1][2] == 14 && ruut[1][3] == 10) {
          while (ruut[3][3] != 10) {
            ViiNumberRuudule (10, 3, 3);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
          while (ruut[3][2] != 14) {
            ViiNumberRuudule (14, 3, 2);
            joonista_laud ((Laud4x4*)this);
            rest (viide);
          }
        }
      }

      if (ViiNumberRuudule (skript[skriptisamm][SKRIPT_NUMBER], 
          skript[skriptisamm][SKRIPT_X], skript[skriptisamm][SKRIPT_Y]) == 
          TULEMUS_ONPAIGAS)
        skriptisamm++;

    if (olek == OLEK_M6ISTUS_OTSAS)
      break;

      joonista_laud ((Laud4x4*)this);
      rest (viide);
    }
    olek = OLEK_LAHENDATUD;
    int arv = 1;
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        if (i == 3 && j == 3) {
          if (ruut[j][i] != RUUT_TYHI) {
            olek = OLEK_M6ISTUS_OTSAS;
            break;
          }
        } else {
          if (ruut[j][i] != arv) {
            olek = OLEK_M6ISTUS_OTSAS;
            break;
          }
        }
        arv++;
      }
    }
  }
};
void loe_hiirt (Laud4x4* _laud) {

  if (mouse_b & 1) {
    if (olek == OLEK_LAUA_LUGEMINE) {
      for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
          if ((mouse_x > (220 + j * 65)) && (mouse_x < (280 + j * 65)) && (mouse_y > (110 + i * 65)) && (mouse_y < (170 + i * 65))) {
            if (_laud->ruut[j][i] == RUUT_EITEA) {
              _laud->ruut[j][i] = lisatavnumber;
              lisatavnumber++;
              if (lisatavnumber > 15) {
                for (int k = 0; k < 4; k++) {
                  for (int l = 0; l < 4; l++) {
                    if (_laud->ruut[k][l] == RUUT_EITEA)
                      _laud->ruut[k][l] = RUUT_TYHI;
                  }
                }
                lisatavnumber = 1;
                olek = OLEK_LAHENDAMINE;
                break;
              }
            }
          }
        }
      }
    }
  }
  mouse_b = 0;
}

void joonista_ruut (int _number, int _x, int _y) {
  if (_number == RUUT_EITEA) {
    rectfill (screen, 220 + _x * 65, 110 + _y * 65, 280 + _x * 65, 170 + _y * 65, makecol (0,0,0));
    rectfill (screen, 223 + _x * 65, 113 + _y * 65, 277 + _x * 65, 167 + _y * 65, makecol (255,255,255));
    textprintf_centre (screen, font, 250 + _x * 65, 140 + _y * 65 - (text_height (font) / 2), makecol (0,0,0), "?");      
    return;
  }
  if (_number == RUUT_TYHI) {
    rectfill (screen, 220 + _x * 65, 110 + _y * 65, 280 + _x * 65, 170 + _y * 65, makecol (255,255,255));
    return;
  }
  rectfill (screen, 220 + _x * 65, 110 + _y * 65, 280 + _x * 65, 170 + _y * 65, makecol (0,0,0));
  rectfill (screen, 223 + _x * 65, 113 + _y * 65, 277 + _x * 65, 167 + _y * 65, makecol (255,255,255));
  textprintf_centre (screen, font, 250 + _x * 65, 140 + _y * 65 - (text_height (font) / 2), makecol (0,0,0), "%d", _number);
}

void joonista_laud (Laud4x4* _laud) {
  vsync ();
  scare_mouse ();
  acquire_bitmap (screen);
  textout (screen, font, "* VIISTEIST *", 25, 35, makecol (0,0,0));
  rectfill (screen, 210, 100, 215, 375, makecol (0,0,0));
  rectfill (screen, 480, 100, 485, 375, makecol (0,0,0));
  rectfill (screen, 210, 100, 485, 105, makecol (0,0,0));
  rectfill (screen, 210, 370, 485, 375, makecol (0,0,0));
  
  for (int i = 0; i < 4; i++) {
    for (int j = 0; j < 4; j++) {
      joonista_ruut (_laud->ruut[j][i], j, i);    
    }
  }
  rectfill (screen, 250, 400, 640, 480, makecol (255, 255, 255));
  if (olek == OLEK_LAUA_LUGEMINE) {
    textprintf (screen, font, 250, 400, makecol (0, 0, 0), "Paigutage lauale arv %d.", lisatavnumber);
  }
  if (olek == OLEK_LAHENDAMINE) {
    if (skript[skriptisamm][(SKRIPT_NUMBER)] > 0)
      textprintf (screen, font, 250, 400, makecol (0, 0, 0), "Viin numbrit %d oma kohale.", skript[skriptisamm][(SKRIPT_NUMBER)]);
  }
  if (olek == OLEK_MITTELAHENDUV_SEIS) {
    textprintf (screen, font, 250, 400, makecol (0, 0, 0), "See seis ei ole lahenduv!.");
  }
  if (olek == OLEK_LAHENDATUD) {
    textprintf (screen, font, 250, 400, makecol (0, 0, 0), "Lahendatud!.");
  }
  if (olek == OLEK_M6ISTUS_OTSAS) {
    textprintf (screen, font, 250, 400, makecol (0, 0, 0), "Ma enam ei oska :( (samm %d)", skriptisamm);
  }
  release_bitmap (screen);
  unscare_mouse ();
}

int main () {
  srand(time(0));
  set_uformat(U_ASCII);

  allegro_init ();
  set_window_title ("Viieteistkmnemng!");
  if (desktop_color_depth () == 32)
    set_color_depth (32);
  if (desktop_color_depth () == 16)
    set_color_depth (16);
  if (set_gfx_mode (GFX_AUTODETECT_WINDOWED, 640, 480, 640, 480) < 0) {
    if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 640, 480) < 0) {
      allegro_message ("Pilti nidata ei nnestunud!");
    }
  }
  install_keyboard ();
  install_mouse ();

  clear_to_color (screen, makecol (255,255,255));
  show_mouse (screen);

  DATAFILE* andmed = load_datafile ("TTT.dat");
  font = (FONT*)(andmed[0]).dat;
  text_mode (makecol (255,255,255));

  Laud4x4 laud;
  laud.Tyhjenda ();

  for (int ret = 0; nupud[ret].proc; ret++) {
    nupud[ret].bg = makecol(255, 255, 255);
    nupud[ret].fg = makecol(0, 0, 0);
  }

  while (1) {
    clear_keybuf ();
    joonista_laud (&laud);
    int signal = do_dialog (nupud, 0);
    if (signal == 1)
      exit (0);

    laud.Tyhjenda ();
 
    olek = OLEK_LAUA_LUGEMINE;
    while (olek == OLEK_LAUA_LUGEMINE) {
      joonista_laud (&laud);
      loe_hiirt (&laud);
      rest (50);
      yield_timeslice ();
    }

    olek = OLEK_LAHENDAMINE;
    int lahenduv = laud.SaabLahendada ();
    if (lahenduv) {
      laud.Mangi ();
    } else {
      olek = OLEK_MITTELAHENDUV_SEIS;
    }
  
    joonista_laud (&laud);
  }
  
  return 0;
}
END_OF_MAIN ();